//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "fMain.h"
#include "math.h"
#include "algorithm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
//{ TSink }------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TSink::TSink(Classes::TComponent* AOwner, int Index)
   : TLabel(AOwner)
{
   Color = clLime;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TSink::GetKey()
{
   AnsiString ret;
   return ret.sprintf("%3.3d", Index);
}
//---------------------------------------------------------------------------
void __fastcall TSink::SetEmpty(int Value)
{
   if(Value!=FSinkInfo[8]){
      FSinkInfo[8] = Value;
      if (FSinkInfo[8] == 0)  Color = clLime;
      else                    Color = clRed;
   }
}
//---------------------------------------------------------------------------
float __fastcall TSink::Distance(int X, int Y)
{
   float X1 = Left;
   float Y1 = Top;
   float V = (X-X1)*(X-X1)+(Y-Y1)*(Y-Y1);
   if(V!=0) return sqrt(V);
   return 0.0;
}
//---------------------------------------------------------------------------
//{ TParkingLot }------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TParkingLot::TParkingLot(Classes::TComponent* AOwner)
   : TCustomControl(AOwner)
{
   Color = clGray;
   ConstructSinks();
}
//---------------------------------------------------------------------------
__fastcall TParkingLot::~TParkingLot(void)
{
   DestroySinks();
}
//---------------------------------------------------------------------------
void __fastcall TParkingLot::ConstructSinks()
{
   for(int i=0; i<120; i++){
      FSinks[i] = new TSink(this, i);
      FSinks[i]->Parent = this;
      FSinks[i]->FSinkInfo[0] = i;
   }
   IsConstructed = true;
}
//---------------------------------------------------------------------------
void __fastcall TParkingLot::Paint(void)
{
   if(IsConstructed){
      int w = (Width-20) / 15;
      int h = (Height-20) / 8;
      for(int i=0; i<120; i++){
         int c = i % 15;
         int r = i / 15;
         TRect rect = Rect(w*c, h*r, w*(c+1), h*(r+1));
         OffsetRect(&rect, 10, 10);
         InflateRect(&rect, -1, -10);
         FSinks[i]->BoundsRect = rect;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TParkingLot::DestroySinks()
{
   for(int i=0; i<120; i++){
      delete FSinks[i];
   }
}
//---------------------------------------------------------------------------
TSink* __fastcall TParkingLot::GetSinks(int Index)
{
   if(Index>-1&&Index<120)
      return (TSink*) FSinks[Index];
   return NULL;
}
//---------------------------------------------------------------------------
//{ TForm1 }-----------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   Randomize();
   BestSinkIndex = -1;
   ParkingLot = new TParkingLot(this);
   ParkingLot->Parent = this;
   ParkingLot->BoundsRect = Rect(10,10,340, 440);
   BitBtn1->BoundsRect = Rect(350, 20, 450, 45);
   BitBtn2->BoundsRect = Rect(350, 50, 450, 75);
   Width = BitBtn2->BoundsRect.Right + 20;
   Height = ParkingLot->BoundsRect.Bottom + 60;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
   for(int i=0; i<120; i++){
      ParkingLot->Sinks[random(120)]->Empty = random(MaxInt) % 2;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
   Car->Left = max(0, random(Width-Car->Width*3));
   Car->Top = max(0, random(Height-Car->Height*4));
   Car->BringToFront();

   TStringList *L = new TStringList();
   try{
      L->Sorted = true;
      for(int i=0; i<120; i++){
         TSink *O = ParkingLot->Sinks[i];
         if(O->Empty==0){
            AnsiString SortKey;
            SortKey.sprintf("%10.4f", O->Distance(Car->Left, Car->Top));
            L->AddObject(SortKey, O);
         }
      }

      if(L->Count==0)Label1->Caption = "Ⱥ !!!";
      else{
         AnsiString S;
         TSink* O = (TSink*)L->Objects[0];
         if(O){
            if(O->Index!=BestSinkIndex){
               if(BestSinkIndex!=-1)
                  ParkingLot->Sinks[BestSinkIndex]->Color=clLime;
               O->Color=clYellow;
               BestSinkIndex = O->Index;
               Label1->Caption = S.sprintf("̨ΦmO: %d", O->Index);
            }
         }
      }
   }
   __finally{
      delete L;
   }
}
//---------------------------------------------------------------------------

