//---------------------------------------------------------------------------
#ifndef fMainH
#define fMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>

//---------------------------------------------------------------------------
class TSink : public TLabel
{
private:
   AnsiString __fastcall GetKey();
   void __fastcall SetEmpty(int Value);
public:
   int FSinkInfo[10];
   __fastcall TSink(Classes::TComponent* AOwner, int Index);
   float __fastcall Distance(int X, int Y);
   __property AnsiString Key = {read=GetKey};
   __property int Index = {read=FSinkInfo[0]};
   __property int Node1 = {read=FSinkInfo[1]};
   __property int Node2 = {read=FSinkInfo[2]};
   __property int NodeX1 = {read=FSinkInfo[3]};
   __property int NodeY1 = {read=FSinkInfo[4]};
   __property int NodeX2 = {read=FSinkInfo[5]};
   __property int NodeY2 = {read=FSinkInfo[6]};
   __property int Road = {read=FSinkInfo[7]};
   __property int Empty = {read=FSinkInfo[8], write=SetEmpty};
};
//---------------------------------------------------------------------------
class TParkingLot : public TCustomControl
{
private:
   AnsiString FFileName;
   TSink* FSinks[120];
   TSink* __fastcall GetSinks(int Index);
   void __fastcall ConstructSinks();
   void __fastcall DestroySinks();
protected:
   bool IsConstructed;
   void __fastcall Paint(void);
public:
   __fastcall TParkingLot(Classes::TComponent* AOwner);
   __fastcall ~TParkingLot(void);
   __property TSink* Sinks[int Index]={read=GetSinks};
};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:
   TBitBtn *BitBtn1;
   TPanel *Car;
   TBitBtn *BitBtn2;
   TLabel *Label1;
   void __fastcall BitBtn1Click(TObject *Sender);
   void __fastcall BitBtn2Click(TObject *Sender);
private:
   int BestSinkIndex;
protected:
   TParkingLot* ParkingLot;
public:
   __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
